SystemOrganization addCategory: #'Jet-Browsers'!

!JETChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^ RGColor unchanged ! !

!JETChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 10/10/2011 16:11'!
icon

	self isAddition ifTrue: [ ^ RGMenuIcons addIcon ].
	self isRemoval ifTrue: [ ^ RGMenuIcons deleteIcon ].
	self isModification ifTrue: [ ^ RGMenuIcons editIcon ].
	^RGMenuIcons blankIcon ! !

!JETAddedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^ RGColor green4! !

!JETAddedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:43'!
viewSourceCodeOn: view

	entity viewSourceCodeOn: view diffTo: nil ! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/4/2011 22:55'!
edgesOfOutgoingDeltas: outgoingDeltas incomingDeltas: incomingDeltas on: view
	| outgoingEdges incomingEdges edge allEdges myEdges |

	allEdges := Dictionary new.
	outgoingEdges := Dictionary new.
	outgoingDeltas keysAndValuesDo:[ :key :value|
		myEdges := OrderedCollection new. 
		value do: [ :each | 
			view interaction 
				popupText: [ :from :to| from name, String cr, to name ].			
			edge := (
				view
					edges: { key }
					from: #yourself
					to: each).
			allEdges at: (key->each) put: edge.
			myEdges addAll: edge ].
		outgoingEdges at: key put: myEdges ].
	
	incomingEdges:= Dictionary new.
	incomingDeltas keysAndValuesDo:[ :key :value|
		myEdges := OrderedCollection new. 
		value do:[ :each|
			myEdges addAll: (allEdges at: (each -> key)) ].
		incomingEdges at: key put: myEdges ].
	
	^{ outgoingEdges . incomingEdges }! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/2/2011 11:40'!
forcedLayout 

	^ MOForceBasedLayout new! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/29/2011 14:50'!
resetEdgesOn: view 

	view 
		edges: #() 
		from: #yourself! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/3/2011 11:53'!
treeLayout 

	^MODominanceTreeLayout new
		verticalGap: 80; 
		horizontalGap: 10! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 1/18/2012 10:51'!
viewChangeDependenciesHelp
	| browser list |
	
	list := { (Text string:  'Method/Class explicit dependency' attributes:  {TextEmphasis underlined } ) .
			(Text string:  'Method/Class dependency defined in the same delta' attributes: {TextEmphasis italic }) . 
			('Method/Class implicit dependency of a needed/potential delta') }.
	browser := GLMTabulator new.
	browser title: 'Font styles meanings'.
	browser initialExtent: 500@100.
	browser column: #help.
	browser transmit to: #help; andShow: [ :a |
		a list
			display:[ :e| list ] ].
	browser openOn: list! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/19/2011 14:05'!
viewColorsAndMeaningsOn: view

	view nodeShape withoutBorder.
	view interaction
		nodraggable;
		popupText: [ :each| each value ].
	view nodeShape
		withoutBorder;
		fontSize: 8;
		fillColor: [ :each| each key ];
		text:[ :each| each value ].
	view nodes: JETSnapshotDelta deltaColorsAndMeanings .	
	view verticalLineLayout
		gapSize: 0;
		horizontalGap: 0;
		verticalGap: 2;
		verticalOutGap: 2 ! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/29/2011 14:46'!
viewDeltasDependenciesMap
	| view |
	view := MOViewRenderer title: 'Deltas Dependencies Map'.
	self viewDeltasDependenciesMap: view.
	^ view open! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 1/20/2012 09:35'!
viewDeltasDependenciesMap: view
	| outgoingNeededDeltas incomingNeededDeltas neededDeltas edges incomingEdges outgoingEdges incomingPotentialDeltas outgoingPotentialDeltas allOutgoingDeltas allIncomingDeltas |
	
	incomingNeededDeltas := Dictionary new.
	outgoingNeededDeltas := Dictionary new.
	incomingPotentialDeltas := Dictionary new.
	outgoingPotentialDeltas := Dictionary new.
	deltas do:[ :each| 
		neededDeltas := each traversedOutgoingNeededDeltas.
		neededDeltas notEmpty ifTrue: [ 
			outgoingNeededDeltas at: each put: neededDeltas ].
		neededDeltas := each traversedIncomingNeededDeltas.
		neededDeltas notEmpty ifTrue: [ 
			incomingNeededDeltas at: each put: neededDeltas ].
		"neededDeltas := each traversedOutgoingPotentialDeltas.
		neededDeltas notEmpty ifTrue: [ 
			outgoingPotentialDeltas at: each put: neededDeltas ].
		neededDeltas := each traversedIncomingPotentialDeltas.
		neededDeltas notEmpty ifTrue: [ 
			incomingPotentialDeltas at: each put: neededDeltas ]" ].
	allOutgoingDeltas := outgoingNeededDeltas union: outgoingPotentialDeltas.
	allIncomingDeltas := incomingNeededDeltas union: incomingPotentialDeltas.

	view nodeShape 
		height: ((RGNumberLinearNormalizer
						inContext: allIncomingDeltas
						withCommand: [:entity | | border |
							border := (allOutgoingDeltas includesKey: entity) ifTrue: [ (allOutgoingDeltas at: entity) size ] ifFalse:[ 0 ].
							((allIncomingDeltas includesKey: entity) ifTrue: [ (allIncomingDeltas at: entity) size + border ] ifFalse:[ border ]) ]) initialNumber: 20; maxNumber: 100; scale: 2);
		borderWidth: ((RGNumberLinearNormalizer
						inContext: allOutgoingDeltas
						withCommand: [:entity | 
							((allOutgoingDeltas includesKey: entity) ifTrue: [ (allOutgoingDeltas at: entity) size ] ifFalse:[ 0 ]) ]) initialNumber: 1; maxNumber: 8);
		fillColor: [ : e| e lightColorByNeededDeltas ];
		borderColor: [ :e| e colorByNeededDeltas ];
		text: [ :e| e minimalName ];
		textAlignment: #center;
		textVerticalPadding: 3;
		textHorizontalPadding: 2.
	view  interaction 
		popupText: [ :each| each name ].
	view interaction	
		on: MOMouseEnter do: [ :ann | 
			(outgoingEdges at: ann model ifAbsent:[ #() ]) do: [:e | e copyShapeAndDo: [:s | s color: RGColor red; width: 2] ].
			(incomingEdges at: ann model ifAbsent:[ #() ]) do: [:e | e copyShapeAndDo: [:s | s color: RGColor blue; width: 2 ] ] ];
		on: MOMouseLeave do: [ :ann | 
			(outgoingEdges at: ann model ifAbsent:[ #() ]) do: [:e | e copyShapeAndDo: [:s | s color: RGColor gray; width: 1 ] ].
			(incomingEdges at: ann model ifAbsent:[ #() ]) do: [:e | e copyShapeAndDo: [:s | s color: RGColor gray; width: 1 ] ] ];
		on: MOMouseDouble do: [:el | el element model viewDependenciesMap ].	
	view nodes: (allOutgoingDeltas keys union: allIncomingDeltas keys).

	view shape arrowedLine arrowSize: 6.
	edges := self edgesOfOutgoingDeltas: outgoingNeededDeltas incomingDeltas: incomingNeededDeltas on: view.
	view shape arrowedDashedLine arrowSize: 6.
	outgoingEdges := Dictionary newFrom: edges first. 
	incomingEdges := Dictionary newFrom: edges last.
"	edges := self edgesOfOutgoingDeltas: outgoingPotentialDeltas incomingDeltas: incomingPotentialDeltas on: view.	
	outgoingEdges addAll: edges first. 
	incomingEdges addAll: edges last."! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/15/2011 21:04'!
viewDeltasDependenciesMapWithLayout: aLayout
	| view project |
	
	project := RGHistoryRepository current description, ' - ', RGHistoryRepository current prefixPackage.
	view := MOViewRenderer title: 'JET Map: deltas and dependencies (', project, ')'.
	self viewDeltasDependenciesMap: view.
	view layout: aLayout. 		
	^ view open! !

!JETSnapshotDeltaStream methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/6/2011 09:51'!
viewEdgesOfDelta: node with: outgoingDeltas with: incomingDeltas on: view 

	view interaction 
		popupText: [ :from :to| from name, String cr, to name ].
	view
		edges: { node }
		from: #yourself
		toAll: [ :each| outgoingDeltas at: each ifAbsent:[ #() ] ]
		using: (view shape arrowedLine
				arrowSize: 4;
				color: RGColor red).

	view interaction 
		popupText: [ :from :to| from name, String cr, to name ].
	view
		edges: (incomingDeltas at: node ifAbsent:[ #() ])
		from: [ :each| each ]
		to: #yourself
		using: (view shape arrowedLine
				arrowSize: 4;
				color: RGColor blue)! !

!JETSnapshotDelta classSide methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 1/5/2012 19:58'!
deltaColorsAndMeanings

	^ {
		 RGColor lightPink -> 'Delta is an island'.
		 RGColor lightGreen -> 'Delta is a source'.
		 RGColor veryLightGray -> 'Delta is an end'.
		 RGColor lightOrange -> 'Delta is an intermediate'.
		 RGColor lightYellow -> 'Dependency is unique'.
		 RGColor lightMagenta -> 'Dependency is multiple'
	}! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 23:54'!
colorByNeededDeltas

	self hasNoNeededDeltas 
		ifTrue: [ ^ RGColor red2 ].
	self hasOnlyIncomingNeededDeltas 
		ifTrue: [ ^ RGColor green3 ].
	self hasOnlyOutgoingNeededDeltas 
		ifTrue: [ ^ RGColor darkGray ].
	self hasNeededDeltas 
		ifTrue: [ ^ RGColor lightBrown ].
	^ RGColor transparent ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/4/2011 14:54'!
lightColorByNeededDeltas

	self hasNoNeededDeltas 
		ifTrue: [ ^ RGColor lightPink ].
	self hasOnlyIncomingNeededDeltas 
		ifTrue: [ ^ RGColor lightGreen ].
	self hasOnlyOutgoingNeededDeltas 
		ifTrue: [ ^ RGColor veryLightGray ].
	self hasNeededDeltas 
		ifTrue: [ ^ RGColor lightOrange ].
	^ RGColor transparent ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 21:31'!
resetEdgesOn: view 

	view 
		edges: #() 
		from: #yourself! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 21:32'!
viewDependenciesMap
	| view |
	view := MOViewRenderer title: 'Dependencies Map of Delta: ', self name.
	self viewDependenciesMap: view.
	^ view open! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:49'!
viewDependenciesMap: view
	|  changeDepends neededDeltas fuzzyDeltas nodesForEdges dependentDeltas potentialDeltas |
	
	changeDepends := self dependentChanges collect:[ :each| self changeDependencyOf: each ].
	changeDepends := changeDepends reject:[ :each| each hasDependentDeltas not ].
	nodesForEdges := (OrderedCollection new) addAll: changeDepends.
	neededDeltas := self outgoingNeededDeltasMap.
	potentialDeltas := self outgoingPotentialDeltasMap.
	fuzzyDeltas := self outgoingFuzzyDeltasMap.
	dependentDeltas := (OrderedCollection new) addAll: neededDeltas keys; addAll: fuzzyDeltas keys; yourself.
		
	view nodeShape.
	view node: self forIt:[ 				
		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfChangeDependency: enode on: view  ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ] 
			withLayoutUpdate: false.
		view nodeShape 
			width: ((MONumberLinearNormalizer
							inContext: changeDepends
							withCommand: [:e | 5 + (e neededDeltasMap size * 3) ]) scale: 40);			
			height: ((MONumberLinearNormalizer
							inContext: changeDepends
							withCommand: [:e | 5 + (e potentialDeltasMap size * 3) ]) scale: 40);		
			fillColor:[ :e| e change color ].
		view interaction 
			popupText: [ :each| each change fullName ].
		"	popupView: [ :each :popupView | 
				 each change viewSourceCodeOn: popupView ]."
		view nodes: changeDepends.
		view verticalLineLayout verticalGap: 20  ].
	
	view nodeShape.
	view noInteraction.
	view node: self forIt:[ 		
		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfOutgoingFuzzyDelta: enode in: fuzzyDeltas on: view.
				self viewEdgesOfOutgoingNeededDelta: enode in: neededDeltas on: view ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ]
			withLayoutUpdate: false.
		view shape: MOTriangleShape new.
		view nodeShape 
			size: ((MONumberLinearNormalizer
							inContext: neededDeltas keys
							withCommand: [:e | 10 + (neededDeltas at: e) size * 4 ]) scale: 40);		
			fillColor:[ :e| RGColor purple ].
		view interaction popupText: [ :each| each name ].	
		view nodes: neededDeltas keys.

		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfOutgoingFuzzyDelta: enode in: fuzzyDeltas on: view.
			 	self viewEdgesOfOutgoingNeededDelta: enode in: neededDeltas on: view ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ]
			withLayoutUpdate: false.	
		view shape: MOTriangleShape new.
		view nodeShape 
			size: ((MONumberLinearNormalizer
							inContext: potentialDeltas keys
							withCommand: [:e | 10 + (potentialDeltas at: e) size * 4 ]) scale: 40);		
			fillColor:[ :e| RGColor orange ].
		view interaction popupText: [ :each| each name ].	
		view nodes: potentialDeltas keys.
		
		view edges: dependentDeltas 
			from: [ :each| each]
			to: [ :each| each closePredecessor: dependentDeltas ].
		view treeLayout verticalGap: 30
		"view horizontalLineLayout horizontalGap: 30"  ].
		
	view horizontalLineLayout horizontalGap: 100; alignCenter. ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:49'!
viewEdgesOfChangeDependency: node on: view 
	| deps |

	deps := node fuzzyDeltasMap values collect:[ :each| each size ].
	node fuzzyDeltasMap keysAndValuesDo: [ :key :value |
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: (value size)
						"((MONumberLinearNormalizer
							inContext: deps
							withCommand: [:e | value size ]) scale: 5)") ].
	deps := node neededDeltasMap values collect:[ :each| each size ].					
	node neededDeltasMap keysAndValuesDo: [ :key :value |
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor purple;
					width: (value size)
						"((MONumberLinearNormalizer
							inContext: deps
							withCommand: [:e | value size ]) scale: 5)") ].
	view dominanceTreeLayout  ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:47'!
viewEdgesOfOutgoingFuzzyDelta: node in: collection on: view 
	| deps depsSize |
	
	(collection includesKey: node) ifFalse:[ ^self ].
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each fuzzyDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:42'!
viewEdgesOfOutgoingNeededDelta: node in: collection on: view 
	| deps depsSize |
	
	(collection includesKey: node) ifFalse:[ ^self ].
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each neededDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor purple;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:43'!
viewEdgesOfOutgoingPotentialDelta: node in: collection on: view 
	| deps depsSize |
	
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each potentialDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/15/2011 15:55'!
viewVersionHistory
	| view |
	view := MOViewRenderer title: 'History of #', self name.
	self viewVersionHistoryOn: view.
	^ view open! !

!JETSnapshotDelta methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/16/2011 15:55'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 15;
			fillColor:[ :e| Color white ].
		view interaction popupText: [ :each| each name ].	
		view nodes: nodes.
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view treeLayout  ]! !

!JETRemovedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 23:13'!
color

	^ RGColor red4! !

!JETRemovedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:46'!
viewSourceCodeOn: view

	entity viewSourceCodeOn: view diffTo: nil ! !

!JETModifiedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^  RGColor blue3! !

!JETModifiedChange methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:43'!
viewSourceCodeOn: view

	obsoleteEntity viewSourceCodeOn: view diffTo: entity ! !

!JETSubChangeDependency methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 1/6/2012 12:48'!
formattedFullNameBasedOn: aRGSnapshotDelta 

	self delta = self changeDependency delta
		ifTrue: [ ^ Text string:  self change fullName attributes: {TextEmphasis italic} ].
	(self changeDependency delta traversedOutgoingNeededDeltas anySatisfy: [ :each| self delta isOutgoingNeededDeltaOf: each ])	
		ifTrue: [ ^ self change fullName ].
	((self changeDependency delta includesOutgoingNeededDelta: self delta) not
		and:[ self changeDependency delta traversedOutgoingPotentialDeltas anySatisfy: [ :each| self delta isOutgoingNeededDeltaOf: each ] ])	
		ifTrue: [ ^ self change fullName ].
			
	^ Text string:  self change fullName attributes:  {TextEmphasis underlined }
! !

!JETSubChangeDependency methodsFor: '*Jet-Browsers' stamp: 'VeronicaUquillas 12/4/2011 14:55'!
lightColorBasedOn: aRGSnapshotDelta 
 
	^ ((aRGSnapshotDelta includesOutgoingPotentialDelta: self delta)  or:[ self shouldBePotentialDependency ])
		ifTrue: [ RGColor lightMagenta ] 
		ifFalse:[ RGColor lightYellow ] ! !

RGAbstractBrowser subclass: #JETChangeQueryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Browsers'!

!JETChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/8/2011 23:51'!
buildBrowser

	super buildBrowser.
	self onGlobalChanges..
	self onFutureChanges.! !

!JETChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/8/2011 23:51'!
layout

	browser
		row: [ :c| c column: #globalChanges; column: #futureChanges ]! !

!JETChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:56'!
onFutureChanges

	browser transmit to: #futureChanges; andShow: [ :a |
		a list
			title: 'Future changes';
			display: [ :each| self model futureChanges ];
			format: [ :each| each fullName ];
			tags: [ :each | { each delta minimalName } ];	
			whiteRectangledTags;		
			icon: [ :each| each icon ];
			sortBlock: ( [ :e1 :e2| e1 delta visibleID > e2 delta visibleID ])
		].! !

!JETChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:57'!
onGlobalChanges
	
	browser transmit to: #globalChanges; andShow: [ :a |
		a list
			title: 'Global changes';
			display: [ :each| self model globalChanges ];
			format: [ :each| each fullName ];
			tags: [ :each | { each delta minimalName } ];
			whiteRectangledTags;
			icon: [ :each| each icon ];
			sortBlock: ( [ :e1 :e2| e1 delta visibleID > e2 delta visibleID ])
		].! !

!JETChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/8/2011 23:52'!
titleBrowser

	^'Change: ', self model entity name, '   Delta: ', self model delta minimalName ! !

RGAbstractBrowser subclass: #JETDeltaStreamDashboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Browsers'!

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:50'!
baseSnapshotAction: anObject

	^GLMGenericAction new 
		title: 'Browse Base Snapshot'; 
		action: [ anObject selection base browser ]; 
		yourself! !

!JETDeltaStreamDashboard methodsFor: 'building' stamp: 'VeronicaUquillas 12/15/2011 22:18'!
buildBrowser

	super buildBrowser.
	self deltasDependenciesMapAction.
	self onDeltas.
	self onBaseOfDelta.
	self onTargetOfDelta.
	self onBasePackage.
	self onTargetPackage.
	self onGeneralInfo.
	self onDependenciesPerDelta.
	self onChangesPerDelta.
	self onSourceCode.
	self onChangeInfo.
	self onDependenciesPerChangeAndDelta! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:11'!
changesByIncomingNeededDelta: aBrowser

		aBrowser list
			title: 'Changes depending on';
			allowNil;
			display:[ :change :dep :delta | dep changesByIncomingNeededDelta: delta ];
			when:[ :change :dep :delta| delta notNil and:[ dep notNil and:[ (dep changesByIncomingNeededDelta: delta) notEmpty ] ] ];
			icon:[ :each | 
				each changeDependency change icon ];
			format:[ :each| 
				each changeDependency change fullName ];
			whiteRectangledTags;
			tags: [ :each | { { each change icon . each change fullName } } ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 12:55'!
deltasDependenciesMapAction

	browser act: [:f | RGRepositoryHistoryBrowser open ] 
		icon: RGMenuIcons enhancedListIcon 
		entitled: 'Snapshots Browser'.
	browser act: [:f | self model viewDeltasDependenciesMapWithLayout:  self model treeLayout ] 
		icon: RGMenuIcons treeLayoutIcon 
		entitled: 'Deltas Dependencies Tree Map'.
	browser act: [:f | self model viewDeltasDependenciesMapWithLayout: self model forcedLayout ] 
		icon: RGMenuIcons forceBasedLayoutIcon 
		entitled: 'Deltas Dependencies Forced Map'.		! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 13:39'!
dependenciesMapAction: anObject

	^GLMGenericAction new 
		title: 'View Dependencies Map'; 
		action: [ anObject selection viewDependenciesMap ]; 
		yourself! !

!JETDeltaStreamDashboard methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:28'!
dependenciesMapOfChange: change inDelta: delta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep dependenciesMap ]
		ifNil:[ Dictionary new ]! !

!JETDeltaStreamDashboard methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:28'!
dependenciesMapOfChange: change inDelta: delta ofDelta: dependentDelta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep dependenciesMapOfDelta: dependentDelta ]
		ifNil:[ Dictionary new ]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:11'!
dependenciesPerChangeAndDeltaTree: aBrowser

		aBrowser tree
			title: 'Delta dependencies';
			allExpanded;
			when:[ :change :delta :depDelta| (self dependenciesMapOfChange: change inDelta: delta ofDelta: depDelta) notEmpty ];
			display:[ :change :delta :depDelta| (self dependenciesMapOfChange: change inDelta: delta ofDelta: depDelta) keys ];
			icon:[ :each | each isSymbol ifTrue:[ nil ] ifFalse:[ each change icon ] ];
			format:[ :each| each isSymbol
							ifTrue:[ each ]
							ifFalse:[ each change fullName ] ];
			children:[ :each :change :delta :depDelta| | changeDependency |
				changeDependency := delta changeDependencyOf: change.
				changeDependency childrenDependenciesOf: each andDelta: depDelta ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:11'!
dependenciesPerChangeTree: aBrowser

		aBrowser tree
			title: [ :change| (change isMethodChange ifTrue: [ 'Method' ] ifFalse:[ 'Class' ]), ' dependencies' ];
			allExpanded;
			allowNil;
			when:[ :change :delta| change notNil and:[ delta notNil and:[ (self dependenciesMapOfChange: change inDelta: delta) notEmpty ] ] ];
			display:[ :change :delta| (self dependenciesMapOfChange: change inDelta: delta) keys ];
			icon:[ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue:[ each change icon ] ifFalse:[ nil ] ];
			format:[ :each :change :delta| 
				each isRingObject
					ifTrue: [ each isDependency 
							ifTrue: [ each formattedFullNameBasedOn:  delta ] 
							ifFalse:[ each nameWithExternalLabel ] ]
					ifFalse:[ each ] ];
			textBackgroundColor:[ :each :change :delta| 
				each isRingObject
					ifTrue: [ each isDependency 
							ifTrue: [ each lightColorBasedOn: delta ] 
							ifFalse:[ nil ] ]
					ifFalse:[ nil ] ];
			whiteRectangledTags;
			tags: [ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue: [ { each delta minimalName } ] ifFalse:[ #() ] ];
			children:[ :each :change :delta| | changeDependency |
				changeDependency := delta changeDependencyOf: change.
				changeDependency childrenDependenciesOf: each ];
			act: [ :each| self model viewChangeDependenciesHelp ]  icon: RGMenuIcons helpIcon entitled: 'Help'; 
			dynamicActionsOnSelection: [ :each | | excludeAction actions |
				actions := self defaultActions: each.
				excludeAction := self excludeChangeDependencyAction: each.
				excludeAction ifNotNil:[ actions add: excludeAction ].
				actions ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 14:26'!
excludeChangeDependency: anObject
	
	anObject isSymbol
		ifTrue: [ 
			| delta change dependency |
			delta := ((browser paneNamed: #deltas) port: #selection) value.
			change := ((browser paneNamed: #changesOfDelta) port: #selection) value.
			dependency := delta changeDependencyOf: change.
			dependency excludeDependenciesGroupedAs: anObject ]
		ifFalse:[ anObject excludeFromChangeDependency ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/19/2011 11:43'!
excludeChangeDependencyAction: anObject
	
	^ (JETChangeDependency isPossibleToUpdateMap: anObject selection) 
		ifTrue: [
			GLMGenericAction new 
				title: 'Exclude Dependency'; 
				action: [ self excludeChangeDependency: anObject selection.
					     self updatePanelsWhenUpdatingDependencies ]; 
				yourself ]
		ifFalse:[ nil ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:26'!
excludeDeltaRecalculatingAction: anObject
	
	^ anObject selection isExcluded
		ifTrue: [ nil ]
	       ifFalse:[
			GLMGenericAction new 
				title: 'Exclude Delta (recalculating dependencies)'; 
				action: [ self model excludeDeltaRecalculatingDependencies: anObject selection.
					     self updatePanelsWhenUpdatingDeltas ]; 
				yourself ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:25'!
excludeDeltaRemovingAction: anObject
	
	^ anObject selection isExcluded
		ifTrue: [ nil ]
	       ifFalse:[
			GLMGenericAction new 
				title: 'Exclude Delta (removing dependencies)'; 
				action: [ self model excludeDeltaRemovingDependencies: anObject selection.
					     self updatePanelsWhenUpdatingDeltas ]; 
				yourself ]! !

!JETDeltaStreamDashboard methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:27'!
excludedDependenciesMapOfChange: change inDelta: delta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep excludedDependenciesMap ]
		ifNil:[ Dictionary new ]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:11'!
excludedDependenciesPerChangeTree: aBrowser

		aBrowser tree
			title: [ :change| 'Excluded ', (change isMethodChange ifTrue: [ 'method' ] ifFalse:[ 'class' ]), ' dependencies' ];	
			allExpanded;
			allowNil;
			when:[ :change :delta| change notNil and:[ delta notNil and:[ (self excludedDependenciesMapOfChange: change inDelta: delta) notEmpty ] ] ];
			display:[ :change :delta| (self excludedDependenciesMapOfChange: change inDelta: delta) keys ];
			icon:[ :each | 
				each isRingObject ifTrue:[ each change icon ] ifFalse:[ nil ] ];
			format:[ :each| 
				each isRingObject ifTrue: [ each change fullName ] ifFalse:[ each ] ];
			whiteRectangledTags;
			tags: [ :each | 
				each isRingObject ifTrue: [ { each delta minimalName } ] ifFalse:[ #() ] ];
			children:[ :each :change :delta| | changeDependency |
				changeDependency := delta changeDependencyOf: change. 
				changeDependency childrenExcludedDependenciesOf: each ];
			dynamicActionsOnSelection: [ :each | | includeAction actions |
				actions := self defaultActions: each.
				includeAction := self includeChangeDependencyAction: each.
				includeAction ifNotNil:[ actions add: includeAction ].
				actions ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:44'!
historyAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ anObject selection viewVersionHistory ]; 
		yourself! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 14:27'!
includeChangeDependency: anObject
	
	anObject isSymbol
		ifTrue: [ 
			| delta change dependency |
			delta := ((browser paneNamed: #deltas) port: #selection) value.
			change := ((browser paneNamed: #changesOfDelta) port: #selection) value.
			dependency := delta changeDependencyOf: change.
			dependency includeDependenciesGroupedAs: anObject ]
		ifFalse:[ anObject includeFromChangeDependency ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/19/2011 11:43'!
includeChangeDependencyAction: anObject
	
	^ (JETChangeDependency isPossibleToUpdateMap: anObject selection) 
		ifTrue: [
			GLMGenericAction new 
				title: 'Include Dependency'; 
				action: [ self includeChangeDependency: anObject selection.
						 self updatePanelsWhenUpdatingDependencies ]; 
				yourself ]
		ifFalse:[ nil ]! !

!JETDeltaStreamDashboard methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 11/23/2011 22:23'!
initialSelection

	((browser paneNamed: #deltas) port: #selection) value:  self model deltas first! !

!JETDeltaStreamDashboard methodsFor: 'building' stamp: 'VeronicaUquillas 12/15/2011 22:17'!
layout

	browser
		column: [ :c| c row: #deltas span: 4; row: [:r | r column: #baseOfDelta; column: #targetOfDelta ];  row: [:r | r column: #basePackage; column: #targetPackage ]; row: #dependenciesOfDelta span: 2; row: #generalInfo ];
		column: [ :c| c row: [:r | r column: #changesOfDelta; column: [ :r2| r2 row: #sourceCode; row: #info size: 23 ]  span: 2 ]; 
					   row: #dependenciesOfChange ] span: 2.5! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/19/2011 14:11'!
metricsAction: anObject

	^GLMGenericAction new 
		title: 'Query Browser'; 
		action: [ 
			anObject selection isMethodChange 
				ifTrue: [ JETMethodChangeQueryBrowser open: anObject selection ]
				ifFalse:[ JETChangeQueryBrowser open: anObject selection ] ]; 
		yourself! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:03'!
onBaseOfDelta

	browser transmit to: #baseOfDelta; from: #deltas; andShow: [ :a |
		a list
			title: 'Base snapshot packages';
			display: [ :each| each base packagesButExternal ];
			format:[ :each| each versionName ];
			when:[ :each| each base isNilHistory not ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each) ].
		].
	
	browser transmit to: #baseOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [ :delta | 
			| packages |
			delta base isNilHistory 
				ifTrue: [ packages := #() ]
				ifFalse:[ packages := delta base packagesButExternal ].
			packages isEmpty ifTrue: [ nil ] ifFalse:[ packages first ] ]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:08'!
onBasePackage

	browser transmit to: #basePackage; from: #baseOfDelta; andShow: [ :a |
		a text
			display: [ :each| each commitMessage ]
		].! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/11/2012 16:16'!
onChangeInfo

	browser transmit to: #info; from: #changesOfDelta; andShow: [ :a |
		a text
			display: [ :each| | info |
				info := ''.
				each isMethodChange ifTrue: [
					each isModification 
						ifTrue: [ info := '{', each obsoleteEntity protocol, '}  ', each obsoleteEntity stamp, '      =>      ' ].
					info := info, '{', each entity protocol, '}  ', each entity stamp ].
				(each isClassChange and:[ each isMetaclassChange not and:[ each entity hasComment ]]) ifTrue: [
					(each isModification and:[ each obsoleteEntity hasComment ])
						ifTrue: [ info := each obsoleteEntity stamp, '          =>          ' ].
					info := info, each entity stamp ].
				info ]	
		]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:03'!
onChangesPerDelta

	browser transmit to: #changesOfDelta; from: #deltas; andShow: [ :a |
		a list
			title: 'Changes with dependencies';
			allowDeselection;
			display:[ :each| each dependentChanges ];
			sorted: self sortBlockByFullName;
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			whiteRectangledTags;
			tags: [ :each | | tags |
				tags := OrderedCollection new.
				tags add: each numberOfChangesRelation.
				each isMethodChange ifTrue: [ 
					tags add: each entity numberOfSendersRelation;
						 add: each entity numberOfImplementorsRelation ].
				tags ];
			when:[ :each| each dependentChanges notEmpty ];
			showOnly: 50;
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self metricsAction: each);
					yourself ].
		a list
			title: 'Changes without dependencies';
			allowDeselection;
			display:[ :each| each nonDependentChanges ];
			sorted: self sortBlockByFullName;
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			whiteRectangledTags;
			tags: [ :each | | tags |
				tags := OrderedCollection new.
				tags add: each numberOfChangesRelation.
				each isMethodChange ifTrue: [ 
					tags add: each entity numberOfSendersRelation;
						 add: each entity numberOfImplementorsRelation  ].
				tags ];
			when:[ :each| each nonDependentChanges notEmpty ];
			showOnly: 50;
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self metricsAction: each);
					yourself ]
		].
	browser transmit to: #changesOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [:delta | 
			| changes |
			changes := self sortByFullName: (delta dependentChanges).
			changes isEmpty ifTrue: [ changes := self sortByFullName: (delta nonDependentChanges) ].
			changes isEmpty ifTrue: [ nil ] ifFalse:[ changes first ] ]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/5/2012 14:53'!
onDeltas

	browser transmit to: #deltas; andShow: [ :a |
		a list
			title: 'Deltas';
			display: (self model deltas);
			format:[ :each| each visibleID asString, '. ', each target commitMessagesLabel  ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas alpha: 0.7 ];
			dynamicActionsOnSelection: [ :each | | myActions |
				myActions := 
				(self defaultActions: each) 
					add: (self targetSnapshotAction: each); 
					add: (self baseSnapshotAction: each); 
					add: (self historyAction: each);
					add: (self dependenciesMapAction: each);
				yourself.
				(self excludeDeltaRemovingAction: each) ifNotNil:[ :act|  myActions add: act ].
				(self excludeDeltaRecalculatingAction: each) ifNotNil:[ :act|  myActions add: act ].
				myActions  ].
		a tree
			title: 'Summary';
			noSelection;
			allExpanded;
			display: self model metricGroups;
			children: [ :each| self model metricsOfGroup: each ];
			format: [ :each| 
				(self model metrics includesKey: each)
					ifTrue: [ each, ': ', (self model perform: (self model metrics at: each)) asString ]
					ifFalse:[ each ] ];
			sorted
			]	! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:10'!
onDependenciesPerChangeAndDelta

	browser
		transmit to: #dependenciesOfChange;
		from: #changesOfDelta;
		from: #deltas;
		from: #dependenciesOfDelta;
		andShow: [ :a|
			self dependenciesPerChangeTree: a.
			self dependenciesPerChangeAndDeltaTree: a.
			self excludedDependenciesPerChangeTree: a.
			self changesByIncomingNeededDelta: a
		]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:02'!
onDependenciesPerDelta

	browser transmit to: #dependenciesOfDelta; from: #deltas; andShow: [ :a |
		a list
			title: 'Needed deltas';
			display:[ :delta| self model sortDeltas: delta traversedOutgoingNeededDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedOutgoingNeededDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
			
		a list
			title: 'Potential deltas';
			display:[ :delta| self model sortDeltas: delta traversedOutgoingPotentialDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedOutgoingPotentialDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
			
		a list
			title: 'Depending on me';
			display:[ :delta| self model sortDeltas: delta traversedIncomingNeededDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedIncomingNeededDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
			
		a list
			title: 'External needed classes';
			display:[ :delta| delta externalNeededClasses ];
			sorted: self sortBlockByName;
			format:[ :each| each ];
			when:[ :each| each externalNeededClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		].! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:01'!
onGeneralInfo

	browser transmit to: #generalInfo; andShow: [ :a |
		a mondrian 
			painting: [ :view |
					self model viewColorsAndMeaningsOn: view ].
		].! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/12/2012 13:59'!
onSourceCode

	browser
		transmit to: #sourceCode;
		from: #changesOfDelta;
		andShow: [ :a|
			a smalltalkCode 
				title: 'Source code';
				when: [ :each| each isMethodChange and:[ each hasChangedSourceCode not ] ];
				display: [ :each| each entity sourceCode ];
				smalltalkClass: [ :each| each entity parent ].
				
			a smalltalkCode 
				title: 'Definition code';
				when: [ :each| each isClassChange and:[ each hasChangedDefinitionSource not ] ];
				display: [ :each| each entity definitionSource ].
					
			a diff
				title: 'Stream diff';
				display: [ :each | { each obsoleteEntity sourceCode . each entity sourceCode } ];
				when:[ :each | each isModification  and:[ each hasChangedSourceCode ] ].

			a diff
				title: 'Working copy diff';
				display: [ :each | { each entity sourceCode . each entity compiledMethod getSource } ];
				when:[ :each | each isMethodChange and:[ each isModification and:[ each entity compiledMethod notNil ]  ] ].

			a diff
				title: 'Definition code diff';
				display: [ :each | { each obsoleteEntity definitionSource . each entity definitionSource } ];
				when:[ :each | each isModification and:[ each hasChangedDefinitionSource ] ].
				
			a list
				title: 'Categories';
				when:[ :each| each isPackageChange and:[ each isModification not or:[ each entity wasModifiedByClasses ] ] ];
				display:[ :each| each entity categories sort ].
			
			a diff
				title: 'Categories diff';
				display: [ :each | { each obsoleteEntity categoriesAsText . each entity categoriesAsText } ];
				when:[ :each | each isPackageChange and:[ each isModification and:[ each entity wasModifiedByDefinition ] ] ].
			]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:01'!
onTargetOfDelta

	browser transmit to: #targetOfDelta; from: #deltas; andShow: [ :a |
		a list
			title: 'Target snapshot packages';
			display: [ :each| each target packagesButExternal ];
			format:[ :each| each versionName ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].
	
	browser transmit to: #targetOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [ :delta | 
			| packages |
			packages := delta target packagesButExternal.
			packages isEmpty ifTrue: [ nil ] ifFalse:[ packages first ] ]! !

!JETDeltaStreamDashboard methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:00'!
onTargetPackage

	browser transmit to: #targetPackage; from: #targetOfDelta; andShow: [ :a |
		a text
			display: [ :each| each commitMessage ]
		].! !

!JETDeltaStreamDashboard methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:06'!
rejectFalsePositives: aCollection

	^ aCollection reject:[ :ref | ref isFalsePositive ]! !

!JETDeltaStreamDashboard methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:08'!
rejectFalsePositivesDep: aCollection

	^ aCollection reject:[ :ref | ref isDependency and:[ ref isFalsePositive ] ]! !

!JETDeltaStreamDashboard methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/25/2011 14:45'!
sortSubDependenciesByFullName: subDependencies

	^ subDependencies sort: [:e1 :e2 | e1 change fullName <= e2 change fullName ]! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:50'!
targetSnapshotAction: anObject

	^GLMGenericAction new 
		title: 'Browse Target Snapshot'; 
		action: [ anObject selection target browser ]; 
		yourself! !

!JETDeltaStreamDashboard methodsFor: 'building' stamp: 'VeronicaUquillas 12/15/2011 21:04'!
titleBrowser
	| project |
	
	project := RGHistoryRepository current description, ' - ', RGHistoryRepository current prefixPackage.
	^ 'JET Dashboard: stream of changes and dependencies (', project, ')'! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:42'!
updatePanelsWhenUpdatingDeltas

	(browser paneNamed: #deltas) update.
	(browser paneNamed: #changesOfDelta) update.
	(browser paneNamed: #dependenciesOfChange) update.
	(browser paneNamed: #dependenciesOfDelta) update! !

!JETDeltaStreamDashboard methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 02:00'!
updatePanelsWhenUpdatingDependencies

	(browser paneNamed: #dependenciesOfChange) update.
	(browser paneNamed: #dependenciesOfDelta) update	! !

RGAbstractBrowser subclass: #JETMethodChangeQueryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Browsers'!

!JETMethodChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/16/2011 09:22'!
buildBrowser

	super buildBrowser.
	self onGlobalChanges..
	self onSourceCode.
	self onChangeInfo.
	self onDependencies.
	self onSnapshotSenders.
	self onFutureSenders.	
	self onSnapshotImplementors.
	self onFutureImplementors.
	self onImageImplementors! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/16/2011 09:23'!
dependenciesMapOfChange: change

	^ (change delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep dependenciesMap ]
		ifNil:[ Dictionary new ]! !

!JETMethodChangeQueryBrowser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 12/9/2011 01:10'!
initialSelection

	((browser paneNamed: #globalChanges) port: #selection) value:  self model! !

!JETMethodChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/16/2011 09:41'!
layout

	browser
		column: [ :r| r row: #globalChanges; row: #dependencies  span: 2 ];
		column: [ :r| r row: #sourceCode span: 2; row: #info size: 23; 
					row:[ :c| c column: #snapshotSenders; column: #futureSenders ];
					row:[ :c| c column: #snapshotImplementors; column: #futureImplementors; column: #imageImplementors ] ] span: 2! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:57'!
onChangeInfo

	browser transmit to: #info; from: #globalChanges; andShow: [ :a |
		a text
			display: [ :each| | info |
				info := ''.
				each isModification 
					ifTrue: [ info := '{', each obsoleteEntity protocol, '}      ', each obsoleteEntity stamp, '                    =>                    ' ].
				info := info, '{', each entity protocol, '}      ', each entity stamp ]
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:58'!
onDependencies

	browser transmit to: #dependencies; from: #globalChanges; andShow: [ :a |
		a tree
			title: [ :change| (change isMethodChange ifTrue: [ 'Method' ] ifFalse:[ 'Class' ]), ' dependencies' ];
			allExpanded;
			when:[ :change| (self dependenciesMapOfChange: change) notEmpty ];
			display:[ :change| (self dependenciesMapOfChange: change) keys ];
			icon:[ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue:[ each change icon ] ifFalse:[ nil ] ];
			format:[ :each :change| 
				each isRingObject
					ifTrue: [ each isDependency 
							ifTrue: [ each formattedFullNameBasedOn:  change delta ] 
							ifFalse:[ each nameWithExternalLabel ] ]
					ifFalse:[ each ] ];
			textBackgroundColor:[ :each :change | 
				each isRingObject
					ifTrue: [ each isDependency 
							ifTrue: [ each lightColorBasedOn: change delta ] 
							ifFalse:[ nil ] ]
					ifFalse:[ nil ] ];
			whiteRectangledTags;
			tags: [ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue: [ { each delta minimalName } ] ifFalse:[ #() ] ];
			children:[ :each :change| | changeDependency |
				changeDependency := change delta changeDependencyOf: change.
				changeDependency childrenDependenciesOf: each ]
			]! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:58'!
onFutureChanges

	browser transmit to: #futureChanges; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Future changes';
			display: [ :each| each futureChanges ];
			format: [ :each| each fullName ];
			tags: [ :each | { each delta minimalName } ];	
			whiteRectangledTags;		
			icon: [ :each| each icon ];
			sortBlock: ( [ :e1 :e2| e1 delta visibleID > e2 delta visibleID ])
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:58'!
onFutureImplementors

	browser transmit to: #futureImplementors; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Implementors in later snapshots';
			display: [ :each| each entity futureImplementorsNames ];
			textBackgroundColor:[ :each :change | 
				(change entity implementors detect:[ :e| e name = each ] ifNone:[ nil ]) isNil
					ifTrue: [ RGColor lightGreen  ]
					ifFalse:[ nil ] ]
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:58'!
onFutureSenders

	browser transmit to: #futureSenders; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Callers in later snapshots';
			display: [ :each| each entity futureSendersNames ];
			textBackgroundColor:[ :each :change | 
				(change entity senders detect:[ :e| e fullName = each ] ifNone:[ nil ]) isNil
					ifTrue: [ RGColor lightGreen  ]
					ifFalse:[ nil ] ]
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:59'!
onGlobalChanges
	
	browser transmit to: #globalChanges; andShow: [ :a |
		a list
			title: 'Change history';
			display: [ :each| self model globalChanges ];
			format: [ :each| each fullName ];
			tags: [ :each | { each delta minimalName } ];
			whiteRectangledTags;
			icon: [ :each| each icon ];
			sortBlock: ( [ :e1 :e2| e1 delta visibleID > e2 delta visibleID ])
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:59'!
onImageImplementors

	browser transmit to: #imageImplementors; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Implementors in working copy';
			display: [ :each| each entity externalImplementors ];
			sortBlock: self sortBlockByName
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:59'!
onSnapshotImplementors

	browser transmit to: #snapshotImplementors; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Implementors in target snapshot';
			display: [ :each| each entity implementors ];
			format:[ :each| each name ];
			sortBlock: self sortBlockByName;
			textBackgroundColor:[ :each :change | 
				(change delta successors notEmpty and:[ change entity futureImplementors detect:[ :e| e name = each name ] ifNone:[ nil ] ]) isNil
					ifTrue: [ RGColor lightRed  ]
					ifFalse:[ nil ] ]
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 14:00'!
onSnapshotSenders

	browser transmit to: #snapshotSenders; from: #globalChanges; andShow: [ :a |
		a list
			title: 'Callers in target snapshot';
			display: [ :each| each entity senders ];
			format:[ :each| each fullName ];
			sortBlock: self sortBlockByFullName;
			textBackgroundColor:[ :each :change | 
				(change delta successors notEmpty and:[ change entity futureSenders detect:[ :e| e fullName = each fullName ] ifNone:[ nil ] ]) isNil
					ifTrue: [ RGColor lightRed  ]
					ifFalse:[ nil ] ]
		].! !

!JETMethodChangeQueryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/12/2012 13:59'!
onSourceCode
	
	browser
		transmit to: #sourceCode;
		from: #globalChanges;
		andShow: [ :a|
			a smalltalkCode 
				title: 'Source code';
				when: [ :each| each isMethodChange and:[ each hasChangedSourceCode not ] ];
				display: [ :each| each entity sourceCode ];
				smalltalkClass: [ :each| each entity parent ].
				
			a smalltalkCode 
				title: 'Definition code';
				when: [ :each| each isClassChange and:[ each hasChangedDefinitionSource not ] ];
				display: [ :each| each entity definitionSource ].
					
			a diff
				title: 'Stream diff';
				display: [ :each | { each obsoleteEntity sourceCode . each entity sourceCode } ];
				when:[ :each | each isModification  and:[ each hasChangedSourceCode ] ].
			
			a diff
				title: 'Working copy diff';
				display: [ :each | { each entity sourceCode . each entity compiledMethod getSource } ];
				when:[ :each | each isMethodChange and:[ each entity compiledMethod notNil ] ].

	]! !

!JETMethodChangeQueryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/15/2011 20:57'!
titleBrowser

	^'JET Query Browser: ', self model entity fullName! !

RGAbstractBrowser subclass: #JETSnapshotDeltaBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jet-Browsers'!

!JETSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 15:57'!
buildBrowser

	super buildBrowser.
	self onChangesPerType.
	self onChange! !

!JETSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 16:45'!
layout

	browser
		column: #changesPerType; 
		column: #change span: 2! !

!JETSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:55'!
onChange

	browser transmit to: #change; from: #changesPerType; andShow: [ :a |
			a diff
				title: 'Class Definition Diff';
				display: [ :each | { each obsoleteEntity definitionSource . each substituteEntity definitionSource } ];
				when: [ :each | each hasChangedDefinitionSource ].
				
			a text
				title: 'Class Definition';
				forSmalltalk:[  :each | each entity ];
				when: [ :each | each isClassChange and:[ each hasChangedDefinitionSource not ] ];
				display: [ :each | each entity definitionSource ifNil:[ '<extended class>'] ].
				
			a diff
				title: 'Source Code Diff';
				display: [ :each | { each obsoleteEntity sourceCode . each substituteEntity sourceCode } ];
				when: [ :each | each hasChangedSourceCode ].
			a text
				title: 'Source Code';
				forSmalltalk:[  :each | each entity parent ];
				when: [ :each | each isMethodChange and:[ each hasChangedSourceCode not ] ];
				display: [ :each | each entity sourceCode ].
		].! !

!JETSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 1/2/2012 13:55'!
onChangesPerType

	browser transmit to: #changesPerType; andShow: [ :a |
		a tree
			title: 'Changes per Entity Type';
			display: [ :each| self model historyTypes keys sort ];
			sorted: self sortBlockByFullName;
			icon: [ :each | 
				each isSymbol 
					ifTrue: [ nil ]
					ifFalse:[ each icon ] ];
			children:[ :each| 
				each isSymbol
					ifTrue: [ self model changesByEntityType: (self model historyTypes at: each) ]
					ifFalse:[ {} ] ];
			format: [ :each| 
				each isSymbol 
					ifTrue: [ each ]
					ifFalse:[ each fullName ] ]
		].! !

!JETSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/25/2011 23:29'!
titleBrowser

	^self model name! !
